######################################################################
# factorial.s (recursive)
######################################################################
            .data
prompt:     .asciiz "Enter a positiv number:\n"

######################################################################
# main
######################################################################
            .text
            .globl main
main:
            li $v0, 4            # 
            la $a0, prompt       # 
            syscall              # print prompt

            li $v0, 5            # 
            syscall              # read value from imput into $v0

            move $s0, $v0        # store input globally
								 # Begin caller-Prolog:
								 # (1) sichere alle Caller-Saved Register.
								 # Hier: keine!
								 # (2) Übergebe die Argumente.
            move $a0, $s0        # Hier: nur 1 Argument in $a0
								 # (3) Springe zur Unterprozedur
            jal factorial        # Hier: call function factorial
								
								 # Epilog des Callers:
								 # (1) Stelle gesicherte Register wieder her.
								 # Hier: keine vorhanden
								 # Daher kein Epilog noetig.
								 
            move $a0, $v0        # copy result
            li $v0, 1
            syscall              # print result
exit:
            li $v0, 10           # exit programm
            syscall

######################################################################
#  factorial: compute factorial of $a0 (return result in  $v0)
######################################################################
            .text
factorial:
            sub $sp, $sp, 16     # Begin callee-Prolog: Allocate space for stackframe 
            sw $fp, 16($sp)		 # Save callee-saved register $fp
            sw $ra, 12($sp)		 # Save callee-saved register $ra
            sw $s0,  8($sp)      # Save callee-saved register $s0
            add $fp, $sp, 16     # set frame pointer

            sw $a0, -12($fp)     # current value of n; save as local variable!
            move $s0, $a0		 # save current value of n in $s0
                                 
            bgt $s0, 1, recurse  # base case.  return 1
            
            li $v0, 1			 # Begin callee-Epilog: save result to register $v0
            lw $s0, 8($sp)		 # restore calle-saved register: $s0
            lw $ra, 12($sp)		 # restore calle-saved register: $ra
            lw $fp, 16($sp)		 # restore calle-saved register: $fp
            add $sp, $sp, 16	 # remove stack frame
                                 
            jr $ra				 # jump to caller
recurse:   
            sub $a0, $a0, 1      # recursive call. compute (n-1)!
								 # Begin Prolog Caller
								 # Keine Register zu sichern
								 # Argument ist bereits in $a0 
								 # Also: Sprung zur Unterprozedur!
            jal factorial
            mul $v0, $v0, $s0    # n * (n-1)!
            lw $s0, 8($sp)		 # Begin callee-Epilog: restore calle-saved register: $s0
            lw $ra, 12($sp)		 # restore calle-saved register: $ra
            lw $fp, 16($sp)		 # restore calle-saved register: $fp
            add $sp, $sp, 16	 # remove stack frame
      
            jr $ra				 # jump to caller
